/**
 * @file p0.cpp
 * @brief Project 0 implementation.
 *
 * @author Your Name (andrewid)
 * @bug Unimplemented.
 */

/*
    EDIT THIS FILE FOR P0.
 */

#include "p0.hpp"

#include "opengl.hpp"
#include "math/vector.hpp"
#include "scene/camera.hpp"
#include "scene/model.hpp"
#include <iostream>

namespace _462 {

void prj_initialize( Camera* camera, Model* model )
{
    // set some camera paremeters
    camera->fov = PI / 4.0;
    camera->near_clip = 0.1;
    camera->far_clip = 100.0;
    // aspect is set by the application, so we can ignore it

    camera->position = Vector3( 0.0, 0.0, 50.0 );
    camera->orientation = Quaternion::Identity;
    // set focus point at the origin
    camera->focus_dist = camera->position.distance( Vector3::Zero );

    // TODO perform any other initialization here
}

void prj_destroy( Model* model )
{
    // TODO perform any needed cleanup
}

void prj_render( const Camera* camera, Model* model )
{
    // TODO fill in this function with your rendering code

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    glBegin( GL_TRIANGLES );
		glColor3f(1.0, 0.0, 0.0);
		glVertex2d( 0.0, 0.5);
		glColor3f(0.0, 1.0, 0.0);
		glVertex2d(-0.5,-0.5);
		glColor3f(0.0, 0.0, 1.0);
		glVertex2d( 0.5,-0.5);
	glEnd();
}

void prj_set_polygon_mode( PolygonMode mode )
{
    // TODO implement
}

} /* _462 */

